/*28069SPWM*/
#include "DSP28x_Project.h"		//ͷļʾͷļ
#include "IQmathLib.h"
#define PI 3.1415927	//Բ
#define SW_fre  15000L	//ƵΪ15kHz
#define SW_Period  6000L
#define SW_Period14  98304000L
__interrupt void epwm1_isr(void);	//жϺ
unsigned int CTNR_N = 150;	//زΪ150
float Time_Step = 0.020944;	//زµĲ
float Time_Step2 = 0.010472;	//زµĲ0.5
_iq sinout_l;
float sinout_f;
unsigned int Duty_int ;	//ռձȶӦĸ
unsigned int Module = 4965;	//Զ1Vʱĵƶ1/3.3,2^14
int Period_flag = 0;	//ϰں°ڱ־λ
volatile int Step_Count = 0;		//
int Duty = 0;	//عռձȼֵ
void InitEPwm1Example()
{
	EPwm1Regs.TBCTL.bit.CTRMODE = TB_COUNT_UP; //ģʽ
	EPwm1Regs.TBPRD = 6000;       //ePWM1Ϊ4500,90M¶Ӧ20KHz
	EPwm1Regs.TBCTL.bit.PHSEN = TB_DISABLE;    //ֹλװ
	EPwm1Regs.TBPHS.half.TBPHS = 0x0000;       //λΪ0
	EPwm1Regs.TBCTR = 0x0000;                  //ePWMʱ
	EPwm1Regs.TBCTL.bit.PRDLD = TB_SHADOW;		//ֵΪ0Զװֵ
	EPwm1Regs.TBCTL.bit.HSPCLKDIV = TB_DIV1;
	EPwm1Regs.TBCTL.bit.CLKDIV = TB_DIV1;		//ePWMʱƵƵ
	EPwm1Regs.CMPCTL.bit.SHDWAMODE = CC_SHADOW;
	EPwm1Regs.CMPCTL.bit.SHDWBMODE = CC_SHADOW;		//shadowģʽ
	EPwm1Regs.CMPCTL.bit.LOADAMODE = CC_CTR_ZERO;
	EPwm1Regs.CMPCTL.bit.LOADBMODE = CC_CTR_ZERO;	//CMPACMPBCTR=0ʱװ
	EPwm1Regs.CMPA.half.CMPA = 6500;    //CMPA=6500
	EPwm1Regs.CMPB = 6500;              //CMPB=6500
	EPwm1Regs.AQCTLA.bit.ZRO = AQ_CLEAR;            //CTR=0 ePWM1A
	EPwm1Regs.AQCTLA.bit.CAU = AQ_SET;          //CTR=CMPA ePWM1B
	EPwm1Regs.AQCTLB.bit.ZRO = AQ_CLEAR;            //CTR=0 ePWM1B
	EPwm1Regs.AQCTLB.bit.CBU = AQ_SET;          //CTR=CMPB ePWM1B
	EPwm1Regs.ETSEL.bit.INTSEL = ET_CTR_ZERO;     //CTR=0ʹж
	EPwm1Regs.ETSEL.bit.INTEN = 1;                //ʹжINT
	EPwm1Regs.ETPS.bit.INTPRD = ET_1ST;			  //ÿһ¼
}
void main()
{
	InitSysCtrl();			//DSPģʼ
	InitEPwm1Gpio();		//ePWM1GPIOʼ
	DINT;					//жϺPIE
	InitPieCtrl();			//ʼPIEƼĴ
	IER = 0x0000;
	IFR = 0x0000;			//ֹCPUʱжϲб־λ
	InitPieVectTable();		//ʼPIE
	EALLOW;
	PieVectTable.EPWM1_INT = &epwm1_isr;	//װePWMʱжڵַ
	EDIS;
	IER |= M_INT3;	//INT3ʹ
	PieCtrlRegs.PIEIER3.bit.INTx1 = 1;	//ʹePWMж
	EINT;			//ʹȫж
	ERTM;			//ʹܵ¼
	EALLOW;
	SysCtrlRegs.PCLKCR0.bit.TBCLKSYNC = 0;	//ֹͣÿʹePWMģڵTBCLKʱʱӣ
	EDIS;
	InitEPwm1Example();
	EALLOW;
	SysCtrlRegs.PCLKCR0.bit.TBCLKSYNC = 1;	//ʹܵePWMģʱУ׼TBCLKĵһ
	EDIS;
	while(1)
		;
}
__interrupt void epwm1_isr(void)
{
	Step_Count++;
	if((Step_Count > CTNR_N)&&(Period_flag == 0))
	{
		EPwm1Regs.CMPB = 6500;		//ȽBֵ,2,3άֵ͵ƽ
		Step_Count = 0;		//ֵ0
		Period_flag = 1;	//°
	}
	else if((Step_Count > CTNR_N)&&(Period_flag == 1))
	{
		EPwm1Regs.CMPA.half.CMPA = 6500;	// ȽAֵ,1,4άֵ͵ƽ
		Step_Count = 0;	//ֵ0
		Period_flag = 0;	//ϰ
	}
	sinout_l = _IQ27sin(_IQ27(0.1));
	sinout_f = _IQ27toF(sinout_l);
	//Duty_int = Module * sin(Step_Count * Time_Step + Time_Step2);
	if(Period_flag == 0)	//ϰ
	{
		Duty = (SW_Period14 - (Duty_int * SW_Period)) >> 14 ;	//1,4ռձ
		EPwm1Regs.CMPA.half.CMPA = Duty;	//1,4ռձȱȽֵ
	}
	else if(Period_flag == 1)	//°
	{
		Duty = (SW_Period14 - (Duty_int * SW_Period)) >> 14;	//2,3ռձ
		EPwm1Regs.CMPB = Duty;
	}
    EPwm1Regs.ETCLR.bit.INT = 1;	//ETFLG[INT]־λٲж
    PieCtrlRegs.PIEACK.all = PIEACK_GROUP3;
    //Ӧж3ж,,Ϊÿνжϻܸж
}

